const puppeteer = require('puppeteer-core');

(async () => {
  try {
    const browser = await puppeteer.launch({
      executablePath: '/usr/bin/chromium-browser',
      args: ['--headless', '--no-sandbox', '--ignore-certificate-errors', '--start-maximized'],
      headless: false
    });

    const timestamp = new Date().getTime();
    const screenshotPath = '/usr/local/opmon/utils/CheckUp_OpMon/puppeteer/generate_screenshot/screenshots/';
    const screenshotNameA = 'visaotatica.jpg';

    const page = await browser.newPage();
    await page.setViewport({
      width: 1920,
      height: 1080,
      isLandscape: true
    });
    await page.setDefaultNavigationTimeout(0);

    var user = 'neoson';
    var password = 'b4ckT0Th3Futur3!ByN30s0n';

    await page.goto('https://localhost/opmon/', {
      waitUntil: 'networkidle2',
    });

    const navigationPromise = page.waitForNavigation();

    await page.waitForSelector('input[type="text"]')
    await page.type('input[type="text"]', user);
    await page.waitForTimeout(4000);

    await page.waitForSelector('input[type="password"]')
    await page.type('input[type="password"]', password);
    await page.waitForTimeout(4000);
    
    await page.waitForSelector('button[type="submit"]')
    await page.click('[type=submit]')
    await page.waitForTimeout(20000);


    await page.screenshot({ path: screenshotPath + screenshotNameA, fullPage: true });


    await browser.close();
  } catch (error) {
    console.log(error);
  }
})();
