#!/usr/bin/php
<?php
#
# This is to be used when we need to add / update or remove itens when updating opmon
#
# Version 1.0 will add the user neoson and he ( The fucking neoson (oi neoson!!)) to its notification commands
#
#

include("/usr/local/opmon/etc/config.php");

set_logged_user('opmonadmin');
$cfg = new ConfigManager();

/* Add user naeoson The Man to OpMon */
$username = "neoson";
$contact_id = $cfg->cfg->return_contact_id_by_name($username);
if ($contact_id > 0 &&$contact_id !== false) {
	print "=> $username user already created, rock'nd roll\n";
}
else  {

	$info = array();
	$contact_id = $cfg->cfg->return_contact_id_by_name('opmonadmin');
	$cfg->cfg->get_contact_info($contact_id, $info);

	unset($info['contact_id']);
	unset($info['pager']);
	$info['contact_name'] = $username;
	$info['alias'] = 'The Man that automates everything - oi neoson';
	$info['password'] = '';
	$info['expire_time'] = null;
	$cfg->cfg->add_contact($info);

	$contact_id = $cfg->cfg->return_contact_id_by_name($username);

	// Add default notification commands
	$host_command = $cfg->cfg->return_command_id_by_name("host-notify-by-email-html");
	if ($host_command > 0) {
	    $option = array( "contact_id" => $contact_id,  "notification_type" => "host", "command_id" => $host_command );
	    $cfg->cfg->add_contacts_notification_command($contact_id, $option );
	}

	$service_command = $cfg->cfg->return_command_id_by_name("notify-by-email-html");
	if ($service_command > 0) {
	    $option = array( "contact_id" => $contact_id,  "notification_type" => "service", "command_id" => $service_command );
	    $cfg->cfg->add_contacts_notification_command($contact_id, $option );
	}
	print "=> user $username added\n";
}

/* Add inteface bandwitdh system command */
$system_command =  $cfg->cfg->return_command_id_by_name("system-interface-bandwidth");
if ($system_command > 0) {
	print "=> Command system-interface-bandwidth already exists, rock'nd roll\n";
}
else {
	$command = array();
	$command['command_name'] = "system-interface-bandwidth";
	$command['command_line'] = "/usr/local/opmon/libexec/opservices/op-snmp-interface-bandwidth -h \$HOSTADDRESS\$:\$_HOSTSNMP_PORT\$ -v \$_HOSTSNMP_VERSION\$ -c '\$_HOSTCOMMUNITY\$' -r '\$_HOSTSNMP_RETRIES\$' -t '\$_HOSTSNMP_TIMEOUT\$' -a '\$_HOSTAUTHENTICATION_PROTOCOL\$' -A '\$_HOSTAUTHENTICATION_PASSPHRASE\$' -l '\$_HOSTSECURITY_LEVEL\$' -n '\$_HOSTCONTEXT_NAME\$' -u '\$_HOSTSECURITY_USERNAME\$' -x '\$_HOSTPRIVACY_PROTOCOL\$' -X '\$_HOSTPRIVACY_PROTOCOL_PASSPHRASE\$' -Z '\$_HOSTDESTINATION_ENGINE\$' -I '\$ARG1\$' -W '\$ARG2\$' -C '\$ARG3\$' -s '\$ARG4\$' -m '\$ARG5\$'";
	$command['command_desc'] = "Monitors interface bandwidth";
	$command['system'] = 1;
	$command['command_type'] = 1;
	$cfg->cfg->add_command($command);
	print "=> Command system-interface-bandwidth added\n";
}

/* Add inteface discards system command */
$command_name = "system-interface-discards";
$system_command =  $cfg->cfg->return_command_id_by_name($command_name);
if ($system_command > 0) {
	print "=> Command $command_name already exists, rock'nd roll\n";
}
else {
	$command = array();
	$command['command_name'] = $command_name;
	$command['command_line'] = "/usr/local/opmon/libexec/opservices/op-snmp-interface-discards -h \$HOSTADDRESS\$:\$_HOSTSNMP_PORT\$ -v \$_HOSTSNMP_VERSION\$ -c '\$_HOSTCOMMUNITY\$' -r '\$_HOSTSNMP_RETRIES\$' -t '\$_HOSTSNMP_TIMEOUT\$' -a '\$_HOSTAUTHENTICATION_PROTOCOL\$' -A '\$_HOSTAUTHENTICATION_PASSPHRASE\$' -l '\$_HOSTSECURITY_LEVEL\$' -n '\$_HOSTCONTEXT_NAME\$' -u '\$_HOSTSECURITY_USERNAME\$' -x '\$_HOSTPRIVACY_PROTOCOL\$' -X '\$_HOSTPRIVACY_PROTOCOL_PASSPHRASE\$' -Z '\$_HOSTDESTINATION_ENGINE\$' -I '\$ARG1\$' -W '\$ARG2\$' -C '\$ARG3\$' -s '\$ARG4\$' -m '\$ARG5\$'";
	$command['command_desc'] = "Monitors interface discards";
	$command['system'] = 1;
	$command['command_type'] = 1;
	$cfg->cfg->add_command($command);
	print "=> Command $command_name added\n";
}

/* Add inteface discards system command */
$command_name = "system-interface-errors";
$system_command =  $cfg->cfg->return_command_id_by_name($command_name);
if ($system_command > 0) {
	print "=> Command $command_name already exists, rock'nd roll\n";
}
else {
	$command = array();
	$command['command_name'] = $command_name;
	$command['command_line'] = "/usr/local/opmon/libexec/opservices/op-snmp-interface-errors -h \$HOSTADDRESS\$:\$_HOSTSNMP_PORT\$ -v \$_HOSTSNMP_VERSION\$ -c '\$_HOSTCOMMUNITY\$' -r '\$_HOSTSNMP_RETRIES\$' -t '\$_HOSTSNMP_TIMEOUT\$' -a '\$_HOSTAUTHENTICATION_PROTOCOL\$' -A '\$_HOSTAUTHENTICATION_PASSPHRASE\$' -l '\$_HOSTSECURITY_LEVEL\$' -n '\$_HOSTCONTEXT_NAME\$' -u '\$_HOSTSECURITY_USERNAME\$' -x '\$_HOSTPRIVACY_PROTOCOL\$' -X '\$_HOSTPRIVACY_PROTOCOL_PASSPHRASE\$' -Z '\$_HOSTDESTINATION_ENGINE\$' -I '\$ARG1\$' -W '\$ARG2\$' -C '\$ARG3\$' -s '\$ARG4\$' -m '\$ARG5\$'";
	$command['command_desc'] = "Monitors interface errors";
	$command['system'] = 1;
	$command['command_type'] = 1;
	$cfg->cfg->add_command($command);
	print "=> Command $command_name added\n";
}

/* Add snmp system processor command */
$command_name = "system-processorLoad";
$system_command =  $cfg->cfg->return_command_id_by_name($command_name);
if ($system_command > 0) {
	print "=> Command $command_name already exists, rock'nd roll\n";
}
else {
	$command = array();
	$command['command_name'] = $command_name;
	$command['command_line'] = "/usr/local/opmon/libexec/opservices/op-snmp-processorLoad -h \$HOSTADDRESS\$:\$_HOSTSNMP_PORT\$ -v \$_HOSTSNMP_VERSION\$ -c '\$_HOSTCOMMUNITY\$' -r '\$_HOSTSNMP_RETRIES\$' -t '\$_HOSTSNMP_TIMEOUT\$' -a '\$_HOSTAUTHENTICATION_PROTOCOL\$' -A '\$_HOSTAUTHENTICATION_PASSPHRASE\$' -l '\$_HOSTSECURITY_LEVEL\$' -n '\$_HOSTCONTEXT_NAME\$' -u '\$_HOSTSECURITY_USERNAME\$' -x '\$_HOSTPRIVACY_PROTOCOL\$' -X '\$_HOSTPRIVACY_PROTOCOL_PASSPHRASE\$' -Z '\$_HOSTDESTINATION_ENGINE\$' -W '\$ARG1\$' -C '\$ARG2\$'";
	$command['command_desc'] = "Monitors processor Load";
	$command['system'] = 1;
	$command['command_type'] = 1;
	$cfg->cfg->add_command($command);
	print "=> Command $command_name added\n";
}

/* Add snmp storage system system command */
$command_name = "system-snmp-storage-noid";
$system_command =  $cfg->cfg->return_command_id_by_name($command_name);
if ($system_command > 0) {
	print "=> Command $command_name already exists, rock'nd roll\n";
}
else {
	$command = array();
	$command['command_name'] = $command_name;
	$command['command_line'] = "/usr/local/opmon/libexec/opservices/op-snmp-storage-noid -h \$HOSTADDRESS\$:\$_HOSTSNMP_PORT\$ -v \$_HOSTSNMP_VERSION\$ -c '\$_HOSTCOMMUNITY\$' -r '\$_HOSTSNMP_RETRIES\$' -t '\$_HOSTSNMP_TIMEOUT\$' -a '\$_HOSTAUTHENTICATION_PROTOCOL\$' -A '\$_HOSTAUTHENTICATION_PASSPHRASE\$' -l '\$_HOSTSECURITY_LEVEL\$' -n '\$_HOSTCONTEXT_NAME\$' -u '\$_HOSTSECURITY_USERNAME\$' -x '\$_HOSTPRIVACY_PROTOCOL\$' -X '\$_HOSTPRIVACY_PROTOCOL_PASSPHRASE\$' -Z '\$_HOSTDESTINATION_ENGINE\$' -f '\$ARG1\$' -W '\$ARG2\$' -C '\$ARG3\$'";
	$command['command_desc'] = "Monitors storage device usage";
	$command['system'] = 1;
	$command['command_type'] = 1;
	$cfg->cfg->add_command($command);
	print "=> Command $command_name added\n";
}

/* Add snmp system unix load command */
$command_name = "system-snmp-unix-load-noid";
$system_command =  $cfg->cfg->return_command_id_by_name($command_name);
if ($system_command > 0) {
	print "=> Command $command_name already exists, rock'nd roll\n";
}
else {
	$command = array();
	$command['command_name'] = $command_name;
	$command['command_line'] = "/usr/local/opmon/libexec/opservices/op-snmp-load-unix-noid -h \$HOSTADDRESS\$:\$_HOSTSNMP_PORT\$ -v \$_HOSTSNMP_VERSION\$ -c '\$_HOSTCOMMUNITY\$' -r '\$_HOSTSNMP_RETRIES\$' -t '\$_HOSTSNMP_TIMEOUT\$' -a '\$_HOSTAUTHENTICATION_PROTOCOL\$' -A '\$_HOSTAUTHENTICATION_PASSPHRASE\$' -l '\$_HOSTSECURITY_LEVEL\$' -n '\$_HOSTCONTEXT_NAME\$' -u '\$_HOSTSECURITY_USERNAME\$' -x '\$_HOSTPRIVACY_PROTOCOL\$' -X '\$_HOSTPRIVACY_PROTOCOL_PASSPHRASE\$' -Z '\$_HOSTDESTINATION_ENGINE\$' -W '\$ARG1\$' -C '\$ARG2\$'";
	$command['command_desc'] = "Monitors unix load";
	$command['system'] = 1;
	$command['command_type'] = 1;
	$cfg->cfg->add_command($command);
	print "=> Command $command_name added\n";
}

/* Add snmp process command */
$command_name = "system-snmp-process-noid";
$system_command =  $cfg->cfg->return_command_id_by_name($command_name);
if ($system_command > 0) {
	print "=> Command $command_name already exists, rock'nd roll\n";
}
else {
	$command = array();
	$command['command_name'] = $command_name;
	$command['command_line'] = "/usr/local/opmon/libexec/opservices/op-snmp-process-noid -h \$HOSTADDRESS\$:\$_HOSTSNMP_PORT\$ -v \$_HOSTSNMP_VERSION\$ -c '\$_HOSTCOMMUNITY\$' -r '\$_HOSTSNMP_RETRIES\$' -t '\$_HOSTSNMP_TIMEOUT\$' -a '\$_HOSTAUTHENTICATION_PROTOCOL\$' -A '\$_HOSTAUTHENTICATION_PASSPHRASE\$' -l '\$_HOSTSECURITY_LEVEL\$' -n '\$_HOSTCONTEXT_NAME\$' -u '\$_HOSTSECURITY_USERNAME\$' -x '\$_HOSTPRIVACY_PROTOCOL\$' -X '\$_HOSTPRIVACY_PROTOCOL_PASSPHRASE\$' -Z '\$_HOSTDESTINATION_ENGINE\$' -f '\$ARG1\$' -W '\$ARG2\$' -C '\$ARG3\$'";
	$command['command_desc'] = "Monitors running process";
	$command['system'] = 1;
	$command['command_type'] = 1;
	$cfg->cfg->add_command($command);
	print "=> Command $command_name added\n";
}

/* Add snmp windows service command */
$command_name = "system-snmp-winservice-noid";
$system_command =  $cfg->cfg->return_command_id_by_name($command_name);
if ($system_command > 0) {
	print "=> Command $command_name already exists, rock'nd roll\n";
}
else {
	$command = array();
	$command['command_name'] = $command_name;
	$command['command_line'] = "/usr/local/opmon/libexec/opservices/op-snmp-winservice-noid -h \$HOSTADDRESS\$:\$_HOSTSNMP_PORT\$ -v \$_HOSTSNMP_VERSION\$ -c '\$_HOSTCOMMUNITY\$' -r '\$_HOSTSNMP_RETRIES\$' -t '\$_HOSTSNMP_TIMEOUT\$' -a '\$_HOSTAUTHENTICATION_PROTOCOL\$' -A '\$_HOSTAUTHENTICATION_PASSPHRASE\$' -l '\$_HOSTSECURITY_LEVEL\$' -n '\$_HOSTCONTEXT_NAME\$' -u '\$_HOSTSECURITY_USERNAME\$' -x '\$_HOSTPRIVACY_PROTOCOL\$' -X '\$_HOSTPRIVACY_PROTOCOL_PASSPHRASE\$' -Z '\$_HOSTDESTINATION_ENGINE\$' -f '\$ARG1\$' -W '\$ARG2\$' -C '\$ARG3\$'";
	$command['command_desc'] = "Monitors running windows service";
	$command['system'] = 1;
	$command['command_type'] = 1;
	$cfg->cfg->add_command($command);
	print "=> Command $command_name added\n";
}

/* Add snmp system unix load command */
$command_name = "system-snmp-uptime-noid";
$system_command =  $cfg->cfg->return_command_id_by_name($command_name);
if ($system_command > 0) {
	print "=> Command $command_name already exists, rock'nd roll\n";
}
else {
	$command = array();
	$command['command_name'] = $command_name;
	$command['command_line'] = "/usr/local/opmon/libexec/opservices/op-snmp-uptime-noid -h \$HOSTADDRESS\$:\$_HOSTSNMP_PORT\$ -v \$_HOSTSNMP_VERSION\$ -c '\$_HOSTCOMMUNITY\$' -r '\$_HOSTSNMP_RETRIES\$' -t '\$_HOSTSNMP_TIMEOUT\$' -a '\$_HOSTAUTHENTICATION_PROTOCOL\$' -A '\$_HOSTAUTHENTICATION_PASSPHRASE\$' -l '\$_HOSTSECURITY_LEVEL\$' -n '\$_HOSTCONTEXT_NAME\$' -u '\$_HOSTSECURITY_USERNAME\$' -x '\$_HOSTPRIVACY_PROTOCOL\$' -X '\$_HOSTPRIVACY_PROTOCOL_PASSPHRASE\$' -Z '\$_HOSTDESTINATION_ENGINE\$' -W '\$ARG1\$' -C '\$ARG2\$'";
	$command['command_desc'] = "Monitors uptime";
	$command['system'] = 1;
	$command['command_type'] = 1;
	$cfg->cfg->add_command($command);
	print "=> Command $command_name added\n";
}

/* Add snmp process memory */
$command_name = "system-snmp-process-memory";
$system_command =  $cfg->cfg->return_command_id_by_name($command_name);
if ($system_command > 0) {
	print "=> Command $command_name already exists, rock'nd roll\n";
}
else {
	$command = array();
	$command['command_name'] = $command_name;
	$command['command_line'] = "/usr/local/opmon/libexec/opservices/op-snmp-process-memory -h \$HOSTADDRESS\$:\$_HOSTSNMP_PORT\$ -v \$_HOSTSNMP_VERSION\$ -c '\$_HOSTCOMMUNITY\$' -r '\$_HOSTSNMP_RETRIES\$' -t '\$_HOSTSNMP_TIMEOUT\$' -a '\$_HOSTAUTHENTICATION_PROTOCOL\$' -A '\$_HOSTAUTHENTICATION_PASSPHRASE\$' -l '\$_HOSTSECURITY_LEVEL\$' -n '\$_HOSTCONTEXT_NAME\$' -u '\$_HOSTSECURITY_USERNAME\$' -x '\$_HOSTPRIVACY_PROTOCOL\$' -X '\$_HOSTPRIVACY_PROTOCOL_PASSPHRASE\$' -Z '\$_HOSTDESTINATION_ENGINE\$' -f '\$ARG1\$' -W '\$ARG2\$' -C '\$ARG3\$'";
	$command['command_desc'] = "Monitors process memory usage";
	$command['system'] = 1;
	$command['command_type'] = 1;
	$cfg->cfg->add_command($command);
	print "=> Command $command_name added\n";
}

/* Add snmp process cpu */
$command_name = "system-snmp-process-cpu";
$system_command =  $cfg->cfg->return_command_id_by_name($command_name);
if ($system_command > 0) {
	print "=> Command $command_name already exists, rock'nd roll\n";
}
else {
	$command = array();
	$command['command_name'] = $command_name;
	$command['command_line'] = "/usr/local/opmon/libexec/opservices/op-snmp-process-cpu -h \$HOSTADDRESS\$:\$_HOSTSNMP_PORT\$ -v \$_HOSTSNMP_VERSION\$ -c '\$_HOSTCOMMUNITY\$' -r '\$_HOSTSNMP_RETRIES\$' -t '\$_HOSTSNMP_TIMEOUT\$' -a '\$_HOSTAUTHENTICATION_PROTOCOL\$' -A '\$_HOSTAUTHENTICATION_PASSPHRASE\$' -l '\$_HOSTSECURITY_LEVEL\$' -n '\$_HOSTCONTEXT_NAME\$' -u '\$_HOSTSECURITY_USERNAME\$' -x '\$_HOSTPRIVACY_PROTOCOL\$' -X '\$_HOSTPRIVACY_PROTOCOL_PASSPHRASE\$' -Z '\$_HOSTDESTINATION_ENGINE\$' -f '\$ARG1\$' -W '\$ARG2\$' -C '\$ARG3\$'";
	$command['command_desc'] = "Monitors process CPU usage";
	$command['system'] = 1;
	$command['command_type'] = 1;
	$cfg->cfg->add_command($command);
	print "=> Command $command_name added\n";
}

$mainconfig = array();
$cfg->cfg->get_main_conf($mainconfig);
$cfg->cfg->update_livestatus_configuration($mainconfig);


$cfg->apply_configuration();
exit();
