<?php

include "/usr/local/opmon/etc/config.php";

set_logged_user('opmonadmin');

$hosts = get_hosts();

foreach($hosts as $hid => $host) {
	//print_r($host->get_status());
	///$host_array=$host->get_status();
	
	$host_id=$host->get_host_id();
	$host_name=$host->get_host_name();
	
	/* Get last entry in status change / perf table */
	$query="select entry_time, unix_timestamp(entry_time) as t_entry_time from host_state_change_$host_id order by entry_time desc limit 1;";
	$result = do_query( $query, DBOPMON );
	$row = $result->fields;
	$entry_time_perf=$row["entry_time"];
	$t_entry_time_perf=$row["t_entry_time"];
	$result->Close();
	
	/* Get last entry in host_status */
	$query="select last_check, unix_timestamp(last_check) as t_last_check, unix_timestamp(next_check) as t_next_check from host_status where host_id=$host_id;";
	$result = do_query( $query, DBOPMON );
	$row = $result->fields;
	$last_check=$row["last_check"];
	$t_last_check=$row["t_last_check"];
	$t_next_check=$row["t_next_check"];
	$result->Close();
	$time_appart_for_problem=$t_next_check-$t_last_check+600;
	
	$time_apart=$t_last_check-$t_entry_time_perf;
	if ($time_apart<0)
		$time_apart=$time_apart*-1;
	
	if ($time_apart<$time_appart_for_problem) {
		//print "OK - $host_id - $entry_time_perf - $last_check\n";
	}
	else {
		print "ERROR - $host_id - $host_name - $entry_time_perf - $last_check\n";
	}

//	while(!$result->EOF) {
//		$row = $result->fields;
//		$entry_time=$row["entry_time"];
//		print "$entry_time";
//		$result->MoveNext();
//	}
//	print "\n";
//	$result->Close();	

}

/* Check is servces are writing status and performance */ 
foreach($hosts as $hid => $host) {
	//$st = $host->get_status();
	$services = $host->get_services();
	foreach($services as $s) {
		//print_r($s->get_status());
		$host_name=$s->get_host_name();
		$service_description=$s->get_service_description();
		$service=$s->get_status();
		$host_id=$service->host_id;
		$service_id=$service->service_id;
		$cp=$s->get_cp_instance();
		$metric_id_array=$cp->get_metrics();
		$metric_count=count($metric_id_array);
		if ($metric_count==0) { // no performance data, metric_id is 0
			$metric_id_array=array();
			$metric_id_array[]=0;
		}
		
		/* Get last entry in service_status */
		$query="select last_check, unix_timestamp(last_check) as t_last_check,current_state, unix_timestamp(next_check) as t_next_check from service_status where host_id=$host_id and service_id=$service_id;";
		$result = do_query( $query, DBOPMON );
		$row = $result->fields;
		$last_check=$row["last_check"];
		$t_last_check=$row["t_last_check"];
		$t_next_check=$row["t_next_check"];
		$current_state=$row["current_state"];
		$result->Close();
		$time_appart_for_problem=$t_next_check-$t_last_check+600;	

		foreach ($metric_id_array as $metric_id) {
			if ($current_state!=0) {
				continue;
			}
			/* Get last entry in service_status */
			$query="select entry_time, unix_timestamp(entry_time) as t_entry_time from service_state_change_$host_id where 	service_id=$service_id and metric_id=$metric_id order by entry_time desc limit 1;";
			$result = do_query($query, DBOPMON);
			$row = $result->fields;
			$entry_time=$row["entry_time"];
			$t_entry_time=$row["t_entry_time"];
			$result->Close();
			$time_apart=$t_last_check-$t_entry_time;
			if ($time_apart<0) 
				$time_apart=$time_apart*-1;
			
			if ($time_apart>$time_appart_for_problem) {
				print "$current_state $host_name/$host_id - $service_description/$service_id - $metric_id - $last_check/$entry_time - $time_apart\n";
			}
		}
	}
}


exit(0);

?>
