#!/usr/bin/perl

($hostname, $ifname)=@ARGV;

use DBI;
use POSIX;

$DBSERVER="localhost";
$DBNAME="stats";
$DBUSER="root";
$DBPASS="oppass";

if ($#ARGV<1) {
   print "Usage:\n";
   print "clean_nisca_db_ifname.pl <hostname> <interface name>\n";
   exit(2);
}

$start=time();

$dbh = DBI->connect ( "dbi:mysql:dbname=$DBNAME;host=$DBSERVER", "$DBUSER", "$DBPASS");
if ( !defined $dbh ) {
        die "Cannot connect to database!\n";
}
$sql="SELECT distinct id FROM stats_ifs where hostname='$hostname' and if_name='$ifname'";
$sth=$dbh->prepare($sql);
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
while (($id) = $sth->fetchrow()) {
	$sql="select count(*) from stats where if_id=$id";
	$sth2=$dbh->prepare($sql);
	if ( !defined $sth2 ) {
	   die "Cannot prepare statement: $DBI::errstr\n";
	}
	$sth2->execute();
	($count)=$sth2->fetchrow();
	$sth2->finish();

	$sql="delete from stats where if_id=$id";
	print "$count records - ".$sql."\n";
	$sth2=$dbh->prepare($sql);
	if ( !defined $sth2 ) {
	   die "Cannot prepare statement: $DBI::errstr\n";
	}
	$sth2->execute();
	$sth2->finish();

	$sql="select count(*) from interfaces where hostname='$hostname' and if_name='$ifname'";
	$sth2=$dbh->prepare($sql);
	if ( !defined $sth2 ) {
	   die "Cannot prepare statement: $DBI::errstr\n";
	}
	$sth2->execute();
	($count)=$sth2->fetchrow();
	$sth2->finish();
	
	$sql="delete from interfaces where hostname='$hostname' and if_name='$ifname'";
	print "$count records - ".$sql."\n";
	print $sql."\n";
	$sth2=$dbh->prepare($sql);
	if ( !defined $sth2 ) {
	   die "Cannot prepare statement: $DBI::errstr\n";
	}
	$sth2->execute();
	$sth2->finish();
}
$sth->finish();

$sql="select count(*) from stats_ifs where hostname='$hostname' and if_name='$ifname'";
$sth2=$dbh->prepare($sql);
if ( !defined $sth2 ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth2->execute();
($count)=$sth2->fetchrow();
$sth2->finish();

$sql="delete from stats_ifs where hostname='$hostname' and if_name='$ifname'";
print "$count records - ".$sql."\n";
$sth2=$dbh->prepare($sql);
if ( !defined $sth2 ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth2->execute();
$sth2->finish();
$dbh->disconnect();

$end=time();

$elapse_time=$end-$start;
if ($elapse_time>60) {
   $elapse_time=$elapse_time/60;
   print "Elapsed time $elapse_time minutes\n"; 
}
else {
   print "Elapsed time $elapse_time seconds\n"; 
}

exit(0);
