#!/usr/bin/php
<?php
require '/usr/local/opmon/etc/config.php';

$running = shell_exec(
    sprintf(
        "pgrep -f -c %s",
        basename(__FILE__)
    )
);
if ($running >= 2) {
    print "Discovery already running.".PHP_EOL;
    exit;
}

set_logged_user("neoson");

$integrations = Integration\IntegrationEngine::getIntegrationByApp(
    Integration\IntegrationEngine::SnmpForServices
);

foreach ($integrations as $integration) {
    try {
        $obj = new Integration\Manager\SnmpForServices($integration);
        $obj->runDiscovery();
    } catch (Exception $e) {
        continue;
    }
}
