#!/usr/bin/php
<?php
include("/usr/local/opmon/etc/config.php");
set_logged_user('opmonadmin');

print "Disabled\n";
exit(0);

include("/usr/local/opmon/share/oplib/libphp/opmonclasses/Naemon.php");
$naemon = new Naemon(true);

$import_all = false;

if ($import_all === false) {
	$archives_dir = "/usr/local/opmon/var/archives/";

	$cmd = "/bin/ls -1Str $archives_dir | tail -n 1";
	$output = array();
	$ret_code = 0;
	$filename = exec($cmd, $output, $ret_code);
	$filename = trim($filename);
	if (empty($filename)) {
		print "Could not find any archive to import\n";
	}

	$filefull = $archives_dir.$filename;

	$ret = $naemon->processLogFile($filefull);
	print "Processed $filefull - inserted {$ret["inserted"]} / already in DB {$ret["foundInDB"]}\n";
	exit(0);
}


print "Start importing all archives logs\n";
$totalin = 0;
$totalout = 0;
$archivesDir  = "/usr/local/opmon/var/archives/";
$dh = @opendir($archivesDir);
if( false === $dh ) {
	return false;
}
while( $file = readdir( $dh )) {
	if( "." == $file || ".." == $file ){
		continue;
	}
	$filefull = $archivesDir.$file;
	$ret = $naemon->processLogFile($filefull);
	$totalout+= $ret["inserted"];
    $totalin+= $ret["foundInDB"];
    print "Processed $filefull - inserted {$ret["inserted"]} / already in DB {$ret["foundInDB"]}\n";
}
closedir( $dh );
print "Total inserted $totalout / Total already in database $totalin\n";
exit(0);
?>
