<?php

include_once('/usr/local/opmon/etc/config.php');

// Get interfaces
$ifs = array();
$ret = do_query("select * from opmon_rtg", DBOPCFG,OPDB_FETCH_OBJ);
while( !$ret->EOF ) {
	$ifs[] = $ret->fields;
	$ret->MoveNext();
}
$ret->Close();

// Get none period od
$period_id = false;
$ret = do_query("select timeperiod_id from nagios_timeperiods where timeperiod_name = 'none'",DBOPCFG,OPDB_FETCH_OBJ);
if ($ret->RecordCount()) {
	$period_id = $ret->fields->timeperiod_id;
}
$ret->Close();

// Fix interfaces
print " >>> Fixing interfaces config ... \n";
foreach($ifs as $if) {
	$query = sprintf("UPDATE nagios_services SET active_checks_enabled = '1', check_period = '%s' WHERE service_id = '%s'",
			$period_id,
			$if->service_id);
	do_query($query,DBOPCFG);
	//var_dump($query);
}
print "Done!\n";

?>
