<?php
include "/usr/local/opmon/etc/config.php";
set_logged_user('opmonadmin');

$query="SELECT h.address, i.ifidx, h.community, n.snmpversion, o.host_id, o.service_id, s.nedi_ifspeed, h.snmp_port, i.ifname, i.device, i.description FROM opcfg.opmon_nedi as o, opcfg.nagios_hosts as h, nedi.devices as n, nedi.interfaces as i, opcfg.nagios_services as s WHERE o.service_id IS NOT NULL AND o.host_id=h.host_id AND o.device_name=n.name AND o.device_name=i.device AND o.ifname=i.ifname AND o.host_id=s.host_id AND o.service_id=s.service_id;";
$result = do_query( $query, DBOPMON );
print "Migrating Nedi to new opmon_rtg\n";
while(!$result->EOF) {
	print "Migrating {$row->host_id} - {$row->service_id} - {$row->device} - {$row->ifname}\n";
	$row = array_to_object($result->fields);

	/* set opmon_rtg */	
	$sql="INSERT IGNORE INTO opcfg.opmon_rtg VALUES ('{$row->host_id}', '{$row->service_id}','ifName','.1.3.6.1.2.1.31.1.1.1.1', '{$row->ifname}', '{$row->ifname}', '{$row->description}', '{$row->ifidx}','0','0','90','95','0',now());";
	do_query( $sql, DBOPMON );
	
	/* set service to be passive*/
	$sql="UPDATE opcfg.nagios_services set active_checks_enabled='0',passive_checks_enabled='1' where host_id='{$row->host_id}' and service_id='{$row->service_id}';";
	do_query( $sql, DBOPMON );
	
	/* set snmp_version */
	$snmp_version=3;
	if ($row->snmpversion=='1') {
		$snmp_version='1';
	}
	else if ($row->snmpversion=='2') {
		$snmp_version='2c';
	}
	$sql="UPDATE opcfg.nagios_hosts set snmp_version='$snmp_version' where host_id='{$row->host_id}';";
	do_query( $sql, DBOPMON );

	$result->MoveNext();
}
$result->Close();	

print "Done\n";
print "\nPlease export your configuration under OpCFG to activate the changes in RTG\n";
exit(0);

?>
