#!/usr/bin/php
<?php

include_once('/usr/local/opmon/etc/config.php');

$options = getopt("g:");
//$filename = get_temp_file("txt",true);
$hostgroup = (isset($options['g'])) ? $options['g'] : $argv[1];

$filename = "/usr/local/opmon/share/tmp/docs.csv";
print "Writing docs to $filename ...\n";

$fp = fopen($filename,"w");

fprintf($fp,"%s","IC,Atributo de IC,Proxima Revisao,Ultima Revisao,Procedimento Operancional,Endereco,Cidade,UF,Pais,Patrimonio,Observacoes\n");

$hosts = get_all_hosts();
foreach($hosts as $host) {
	//print "{$host->get_host_name()}";
	$groups = array();
	$doc_id = get_documentation_by_object($host->get_host_id());
	if ($doc_id) {
		$doc = load_documentation($doc_id);
		// Processes \r\n's first so they aren't converted twice.
		fprintf($fp,"%s","{$host->get_host_name()},-,{$doc->get_next_revision()},{$doc->get_last_revision()},\"{$doc->text}\",\"{$doc->address}\",\"{$doc->city}\",\"{$doc->uf}\",\"{$doc->country}\",\"{$doc->ptr}\",\"{$doc->obs}\"\n");
	}
	// Service documentation
	$svcs = array();
	$svcs = $host->get_services();
	foreach($svcs as $svc) {
		$doc_id = get_documentation_by_object($host->get_host_id(),$svc->get_service_id());
		if ($doc_id) {
			$doc = load_documentation($doc_id);
			fprintf($fp,"%s","{$host->get_host_name()},{$svc->get_service_description()},{$doc->get_next_revision()},{$doc->get_last_revision()},\"{$doc->text}\",\"{$doc->address}\",\"{$doc->city}\",\"{$doc->uf}\",\"{$doc->country}\",\"{$doc->ptr}\",\"{$doc->obs}\"\n");
		}
	}
}
fclose($fp);
print "Done\n";
exit(0);

$hosts = get_all_hosts();
foreach($hosts as $host) {
	//print "{$host->get_host_name()}";
	$groups = array();
	$groups = $host->get_hostgroups();
	foreach($groups as $group_name) {
		if (stristr($group_name,$hostgroup) !== false) {
			// Host documentation
      $doc_id = get_documentation_by_object($host->get_host_id());
      if ($doc_id) {
				$doc = load_documentation($doc_id);
					fprintf($fp,"%s","{$host->get_host_name()},-,{$doc->get_next_revision()},{$doc->get_last_revision()}\n");
				}
				// Service documentation
				$svcs = array();
				$svcs = $host->get_services();
				foreach($svcs as $svc) {
					$doc_id = get_documentation_by_object($host->get_host_id(),$svc->get_service_id());
					if ($doc_id) {
						$doc = load_documentation($doc_id);
						fprintf($fp,"%s","{$host->get_host_name()},{$svc->get_service_description()},{$doc->get_next_revision()},{$doc->get_last_revision()}\n");
					}
				}
                        //break;
		}
	}
}
fclose($fp);
$filename = basename($filename);
print "<a target='_blank' href='/opmon/tmp/$filename'>Planilha de revisao da documentacao $hostgroup</a>\n";

exit;
?>
