#!/usr/bin/perl -w
#

print "\nhost_remove_name.pl Version 1.0\n";

($hostname)=@ARGV;

if ($#ARGV<0) {
	print "\nUsage: host_remove_name.pl <hostname>\n\n";
	exit(0);
}

print "\n\n";
print "Faca backup dos logs do opmon e pare o opmon antes rodar esse script\n";
print "\n\n";
print "Pressione <ENTER> para continuar\n";
print "\n\n";
$nada=<STDIN>;

$opmon_root_dir="/usr/local/opmon";
$opmon_logs_dir=$opmon_root_dir."/var/archives/";
$opmon_log_dir=$opmon_root_dir."/var/";

opendir(DIR, "$opmon_logs_dir");
@files=readdir(DIR);
close(DIR);

#remove_host_name("/usr/local/opmon/var/archives/opmon-10-18-2002-00.log", $hostname);
#exit(0);

$totalCount=0;
foreach $file (@files) {
	if ( ($file eq ".") or ($file eq "..") ) {
		next;
	}
	#print "$file\n";
	$temp=$opmon_logs_dir.$file;
	$hits=0;
	$hits=remove_host_name($temp, $hostname);
	$totalCount=$totalCount+$hits;
}

# checks current opmon.log
$temp=$opmon_log_dir."opmon.log";
$hits=0;
$hits=remove_host_name($temp, $hostname);
$totalCount=$totalCount+$hits;
print "\nTotal lines removed: $totalCount\n";
exit(0);

sub remove_host_name {
	local ($filename,$hostname)=@_;
	open(FILE, $filename);
	@lines=<FILE>;
	close(FILE);
	
	$new_file="/tmp/opmon-host_change_name.log";
	open(NEWFILE,">$new_file");
	$count=0;
	foreach $line (@lines) {
		chop($line);
		$search_pattern1="HOST ALERT";
		$search_pattern2="SERVICE ALERT";
		$search_pattern3="HOST FLAPPING ALERT";
		$search_pattern4="SERVICE FLAPPING ALERT";
		$search_pattern5="HOST NOTIFICATION";
		$search_pattern6="SERVICE NOTIFICATION";
		if ( ($line=~/$search_pattern1/) or ($line=~/$search_pattern2/) or 
		     ($line=~/$search_pattern3/) or ($line=~/$search_pattern4/) or
		     ($line=~/$search_pattern5/) or ($line=~/$search_pattern6/) ) {
			@parts=split(/[:;]/, $line);
			$indexHostname=1;
			if ( ($parts[0]=~$search_pattern1) or ($parts[0]=~$search_pattern2) or 
			     ($parts[0]=~$search_pattern3) or ($parts[0]=~$search_pattern4) ) {
				$indexHostname=1;
			}
			elsif ( ($parts[0]=~$search_pattern5) or ($parts[0]=~$search_pattern6) ) {
				$indexHostname=2;
			}
			# if split found more then 2 parts and the second is our hostname
			$tempHostname=trimSpaces($parts[$indexHostname]);
			if ( ($#parts >1 ) and ($tempHostname eq $hostname) ) {
				# does't do anything, line gets removed form the log files
				# just count to know how many lines have been updated
				$count++;
			}
			else {
				print NEWFILE $line."\n";
			}
		}
		else {
			print NEWFILE $line."\n";
		}
	}
	close(NEWFILE);
	$temp="/bin/cp -f $new_file $filename";
	system($temp);
	$temp="/bin/sync";
	system($temp);
	unlink($new_file);
	print "$filename - $count hits\n";
	#print $new_file."\n";
	return($count);
}

sub trimSpaces {
	local ($string)=@_;
	
	$string =~s/^\s+//;
	$string =~s/\s+$//;
	
	return($string);
}

# Hostname index is 1
#[1041216498] HOST ALERT: giozza-virtua-fln-01;UP;SOFT;3;PING OK - Packet loss =0%, RTA = 25.84 ms
#[1041216498] SERVICE ALERT: giozza-virtua-fln-01;Opinfo Client;CRITICAL;SOFT;1;C
#[1044051935] HOST FLAPPING ALERT: cisco-restinga-pae-01;STOPPED; Host appears to have stopped flapping (0.0% change < 5.0% threshold)
#[1075529271] SERVICE FLAPPING ALERT: tokstok-diveo-spo-01;Load;STARTED; Service appears to have started flapping (23.3% change > 20.0% threshold)
# Hostname index is 2
#[1101423923] HOST NOTIFICATION: adamo.romeira;dalkia-brascan-speedy-spo;DOWN;host-notify-by-email;Socket timeout after 10 seconds
#[1074285047] SERVICE NOTIFICATION: alessandro;sabemi-diveo-pae-01;VPN-RJO;CRITICAL;notify-by-email;CRITICAL - 10 enviados, 0 recebidos,100% pacotes perdidos
