#!/usr/bin/perl

use DBI;
use POSIX;

$run_cmd="/usr/local/mysql/bin/mysqldump -B opmon --tables acoes --password=oppass > /usr/local/tmp/acoes.sql";
system($run_cmd);

$dbh = DBI->connect ( "dbi:mysql:dbname=opmon;host=localhost","root", "oppass");
if ( !defined $dbh ) {
	die "Cannot connect to database!\n";
}

$sql="alter table acoes add column servicename varchar(64)";
$sth=$dbh->prepare("$sql");
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;
$sth->finish;

$sql="select hostname, acao, username, data_update from acoes";
$sth=$dbh->prepare("$sql");
if ( !defined $sth ) {
   die "Cannot prepare statement: $DBI::errstr\n";
}
$sth->execute;

$search_pattern="#";
while ( ($hostname, $acao, $username, $data_update) = $sth->fetchrow()) {
	if ($hostname=~/$search_pattern/) {
		($newhost, $newservice)=split(/#/,$hostname);
		
		# Insert new structur in the database
		$sql="insert into acoes values ('$newhost', '$acao', '$username', '$data_update', '$newservice')";
		$sth2=$dbh->prepare("$sql");
		if ( !defined $sth2 ) {
		   die "Cannot prepare statement: $DBI::errstr\n";
		}
		$sth2->execute();
		$sth2->finish();
		
		# Delete old entry from database
		$sql="delete from acoes where hostname='$hostname'";
		$sth2=$dbh->prepare("$sql");
		if ( !defined $sth2 ) {
		   die "Cannot prepare statement: $DBI::errstr\n";
		}
		$sth2->execute();
		$sth2->finish();
		print "$hostname converted\n";
	}
}
$sth->finish();

exit(0);
