<?php
include_once "/usr/local/opmon/etc/config.php";


function main()
{

	$hosts = array();
	set_logged_user("opmonadmin");
	$hosts = get_hosts();

	foreach($hosts as $host) {
		migrate_host($host);
		migrate_services($host);
	}

}


function migrate_host(Host $h)
{

	print "Migrating {$h->get_host_name()} alerts...";
	$query = "select * from host_alert where hostname='{$h->get_host_name}'";
	$ret = do_query($query, DBOPMON);

	$counter = 0;
	while(!$ret->EOF) {
		$a = array();
		$a = $ret->fields;

		$output = addslashes($a['extinfo']);
		$query = "insert into host_state_change values (".
			 "'{$a['timestamp']}',{$h->get_host_id()},{$a['status']},{$a['hardsoft']},".
			 "{$a['retry']},{$h->get_max_check_attempts()},'$output')";

		//$result = do_query($query,DBOPMON);
		//$result->Close();

		print "$query\n";
		$counter = print_point($counter);
	}
	$ret->Close();
	print "done.\n";

	print "Migrating {$h->get_host_name()} downtimes...";
	$query = "select * from host_downtime_alert where hostname='{$h->get_host_name}'";
	$ret = do_query($query, DBOPMON);

	$counter = 0;
	while(!$ret->EOF) {
		$a = array();
		$a = $ret->fields;

		$output = addslashes($a['extinfo']);
		$query = "insert into host_downtime values (".
			 "{$a['type']},".
			 "'{$a['timestamp']}',".
			 "{$h->get_host_id()},".
			 "'{$a['timestamp']}',".
			 "'-',". // author name is unknown before version 4.0
			 "'{$a['extinfo']}',".
			 "'')";

		//$result = do_query($query,DBOPMON);
		//$result->Close();

		print "$query\n";
		$counter = print_point($counter);
	}
	$ret->Close();
	print "done.\n";

}

function migrate_services(Host $host)
{
	print "Migrating services for {$host->get_host_name()}...  ";

	foreach($host->get_services() as $service) {

		$query = "select * from service_alert where hostname='{$host->get_host_name()}' ".
			 "and servicename='{$service->get_service_description()}'";

		$ret = do_query($query,DBOPMON);
		$counter = 0;
		while(!$ret->EOF) {

			$a = array();
			$a = $ret->fields;

			$output = addslashes($a['extinfo']);
			$query = "insert into service_state_change values (".
				 "'{$a['timestamp']}',{$host->get_host_id()},{$service->get_service_id()},".
				 "{$a['status']},{$a['hardsoft']},{$a['retry']},{$service->get_max_check_attempts()},".
				 "'$output')"; 

			//$result = do_query($query,DBOPMON);
			//$result->Close();

			//print "$query\n";

			$ret->MoveNext();
			print chr(8);
			$counter = print_point($counter);

		}
		$ret->Close();

	}

	print chr(8)."done\n";
}


function print_point($counter) {

	switch($counter) {
	case 0:
		print "-";
		break;
	case 1:
		print "\\";
		break;
	case 2:
		print "|";
		break;
	case 3:
		print "/";
		$counter = -1;
		break;
	}
	$counter++;
	return $counter;
}


main();
?>
