#!/usr/bin/perl

use strict;

our $version = "1.0";

our $fileset = "/opt/otrs";
our $backup_dir = "/var/tmp/opmondb";
our $tar = "/bin/tar";
our $tar_file = "otrs-conf.tar.gz";

sub _main {

	# Create backup dir
	mkdir($backup_dir);

	# Unlink old file
	unlink($backup_dir . "/" . $tar_file);

	# Create tar file
	system("$tar -czpPf $backup_dir/$tar_file $fileset");
	
}

&_main();
