#!/usr/bin/php
<?php

include "/usr/local/opmon/etc/config.php";

set_logged_user("opmonadmin");
$mod = "EXTERNAL";

function main() {

	// host scheduled downtimes
	$query = "select * ".
	         "from host_downtime ".
	         "where end_time > now()";

	$ret = do_query($query, DBOPMON, OPDB_FETCH_OBJ);
	while(!$ret->EOF) {

		$status_q = "select * ".
		            "from host_status ".
		            "where host_id='{$ret->fields->host_id}' ";

		$status = do_query($status_q, DBOPMON, OPDB_FETCH_OBJ);
		if ($status->RecordCount()) {
			if ($status->fields->scheduled_downtime_depth == 0) {

				print "sched from {$ret->fields->start_time} to {$ret->fields->end_time}\n";
				$query = "update host_status ".
				         "set scheduled_downtime_depth=1 ".
				         "where host_id='{$ret->fields->host_id}' ";
				
				$update_ret = do_query($query,DBOPMON,OPDB_FETCH_OBJ);
				$update_ret->Close();

			}
		}
		$status->Close();

		$ret->MoveNext();
	}
	$ret->Close();

	// service scheduled downtimes
	$query = "select * ".
	         "from service_downtime ".
	         "where end_time > now()";

	$ret = do_query($query, DBOPMON, OPDB_FETCH_OBJ);
	while(!$ret->EOF) {

		$status_q = "select * ".
		            "from service_status ".
		            "where host_id='{$ret->fields->host_id}' ".
		            "and service_id='{$ret->fields->service_id}' ";

		$status = do_query($status_q, DBOPMON, OPDB_FETCH_OBJ);
		if ($status->RecordCount()) {
			if ($status->fields->scheduled_downtime_depth == 0) {

				print "sched from {$ret->fields->start_time} to {$ret->fields->end_time}\n";
				$query = "update service_status ".
				         "set scheduled_downtime_depth=1 ".
				         "where host_id='{$ret->fields->host_id}' ".
				         "and service_id='{$ret->fields->service_id}'";
				
				$update_ret = do_query($query,DBOPMON,OPDB_FETCH_OBJ);
				$update_ret->Close();

			}
		}
		$status->Close();

		$ret->MoveNext();
	}
	$ret->Close();

}

main();
?>
