#!/usr/bin/perl
$conf_file="/etc/my.cnf";
$search_string="tmpdir=/var/tmp";
$search_string2="datadir=";
$tmpfile="/tmp/my.cnf-bkp";
$restart_mysql="/sbin/service mysqld restart";

if ( -e $conf_file ) {
	open(FILE, "<",$conf_file);
	@lines=<FILE>;
	close(FILE);
	
	# check if already changed
	foreach (@lines) {
		$line=$_;
		if ( $line=~/$search_string/ ) {
			print "$conf_file already updated\n";
			exit(0);
		}
	}
	
	open(FILE,">",$tmpfile);
	foreach (@lines) {
		$line=$_;
		if ( $line=~/$search_string2/ ) {
			print FILE "$line";
			$new_line=$search_string."\n";
		}
		else {
			$new_line=$line;
		}
		print FILE $new_line;
	}
	close(FILE);
	$cmd="/bin/cp -f $tmpfile $conf_file";
	system($cmd);
	unlink($tmpfile);
	
	# Checkif mysql is running and restart it
	$process=`ps -ef | grep mysqld | grep -v grep | wc -l`;
	if ($process>0) {
		#print "mysqld restart\n";
		system($restart_mysql);
	}
}
else {
	print "$conf_file does not exist\n";
}
exit(0);
