#!/usr/bin/perl

use strict;

sub main {
	print "Iniciando execucao\n";
	#&stop_opmon;
	&process_opmon_log;
}

&main;

# SUBS 

# stop the opmon processes
sub stop_opmon {
	print "parando processo opmon";
	my $procs = 1;
	while( $procs > 0 ) {
		my $log = `/sbin/service opmon stop`;	
		&logger( $log );
		sleep( 10 );
		$procs = `/bin/ps ax |/bin/grep opmon.cfg |/bin/grep grep --invert-match |/usr/bin/wc -l`;
	}

	return( 1 );
}

# create an backup of file 
# opmon.log an transfer the content to the correct file 
# in var/archives
sub process_opmon_log {
	print "processando log opmon\n";
	&logger( "copying opmon.log to /usr/local/src/opmon.log" );
	my $temp = `/bin/date --date=tomorrow +\%m-\%d-\%G`;
	chomp( $temp );
	my $file = "opmon-".$temp."-00.log";
	`/bin/cp /usr/local/opmon/var/opmon.log /usr/local/src/$file`;	
	#`/bin/mv /usr/local/opmon/var/opmon.log /usr/local/opmon/var/archives/$file`;	
}

# log a line to file
sub logger {
	my $line = shift;
	open( LOG, ">>/tmp/daylight-prevent.log" );
	print LOG "$line";
	print LOG "#######################################\n";
	close( LOG );
}
