#!/usr/bin/php
<?php

include "/usr/local/opmon/etc/config.php";

set_logged_user("opmonadmin");

$oldHost = '';
$query = "SELECT host_id, host_name, service_description from opmon4.service_status;";
$ret = do_query($query, DBOPMON, OPDB_FETCH_OBJ);
while(!$ret->EOF) {
	if (isset($ret->fields->host_id)) {

                if ($ret->fields->host_id != $oldHost) {
			print "Host Fixing state_type for ".$ret->fields->host_name."\t\t";
			$table = "host_state_change_".$ret->fields->host_id;
                        $upSql = "DELETE FROM ".$table." where display_status >= 1 AND current_state = 0;";
                        do_query($upSql, DBOPMON);
			$upSql = "DELETE FROM ".$table." where current_state = 0 and plugin_output like '%CRITICAL%';";
                        do_query($upSql, DBOPMON);
                        $oldHost = $ret->fields->host_id;
			print "Done.\n";
                }

		print "Service Fixing current_state for ".$ret->fields->host_name." - ".$ret->fields->service_description."...\t\t";
		$table = "service_state_change_".$ret->fields->host_id;
                $upSql = "DELETE FROM ".$table." where display_status >= 1 AND current_state = 0;";
                do_query($upSql, DBOPMON);
                $upSql = "DELETE FROM ".$table." where current_state = 0 and plugin_output like '%CRITICAL%';";
                do_query($upSql, DBOPMON);
		print "Done.\n";
	}
	$ret->MoveNext();
}
exit(0);

?>
