#!/usr/bin/php
<?php
include "/usr/local/opmon/etc/config.php";

$fpipe = "/usr/local/opmon/var/rw/opmon.cmd";
if (!file_exists($fpipe)) {
	print "OpMon is stopped. Unable to submit checks\n";
	exit(3);
}

$sql="SELECT host_name, service_description from opmon4.service_status order by 1,2;";
$ret=do_query($sql,DBOPCFG,OPDB_FETCH_OBJ);
while(!$ret->EOF) {
	//print "{$ret->fields->host_name}\t{$ret->fields->service_description}\t\n";
	$timestamp=time();
	$cmdString = "[$timestamp] SCHEDULE_FORCED_SVC_CHECK;{$ret->fields->host_name};{$ret->fields->service_description};$timestamp\n";
	print "$cmdString";
	
	$pipe = fopen($fpipe, "w");
	if ($pipe) {
		fputs($pipe, "$cmdString");
		fclose($pipe);
	} else {
		$command = do_escape_string($cmdString);
		$query = "insert into opmon_cmd (entry_time, cmd)  values (now(), '{$command}')";
		do_query( $query, DBOPMON );
	}
			
	$ret->MoveNext();
}
$ret->Close();
exit(0);
