<?php

print "comment exit(0) if you want to remove jobs from a queue to a file\n";
exit(0);

# Create our client object.
$gmworker= new GearmanWorker();

# Add two job servers, the first on the default 4730 port
$gmworker->addServer("127.0.0.1"); 
# Register function "reverse" with the server. Change the worker function to
# "reverse_fn_fast" for a faster worker with no output.
$gmworker->addFunction("opdb_perfdata", "reverse_fn");

print "Waiting for job...\n";
while($gmworker->work())
{
  if ($gmworker->returnCode() != GEARMAN_SUCCESS)
  {
    echo "return_code: " . $gmworker->returnCode() . "\n";
    break;
  }
}

function reverse_fn($job) {
	print $job->workload()."\n";
}

?>
