<?php

include_once "/usr/local/opmon/etc/config.php";

use Database\Driver\DefaultDB;

$db = new DefaultDB();

$db->prepare('SELECT HARDWARE_ID, fields_6 FROM ocsweb.accountinfo');
$db->execute();
$rows = $db->fetchAll(DefaultDB::FETCH_OBJ);

foreach ($rows as $row) {
        if (! $row->fields_6) {
                continue;
        }
        // 02/06/2014
        // 2004-02-18
        if (preg_match('/(\d{4})-(\d{2})-(\d{2})/', $row->fields_6, $matches)) {
                $year = $matches[1];
                $month = $matches[2];
                $day = $matches[3];
                $date = "{$month}/{$day}/{$year}";
                $query = sprintf("UPDATE ocsweb.accountinfo SET fields_6 = :fields_6 WHERE HARDWARE_ID = :HARDWARE_ID");
                $fields = array(':fields_6' => $date, ':HARDWARE_ID' => $row->HARDWARE_ID);
                var_dump($query, $fields);
                $db->prepare($query);
                $db->execute($fields);
        }
}

