#!/usr/bin/perl

use strict;

our $version = "1.0";

our $fileset = "/etc /usr/local/opmon/etc /usr/local/opmon/libexec /usr/local/opmon/var/status.sav /var/spool/cron /usr/lib/oracle /usr/local/opmon/lic";
our $backup_dir = "/var/tmp/opmondb";
our $tar = "/bin/tar";
our $tar_file = "opmon-conf.tar.gz";

sub _main {

	# Create backup dir
	mkdir($backup_dir);

	# Unlink old file
	unlink($backup_dir . "/" . $tar_file);

	# Create tar file
	system("$tar -czpPf $backup_dir/$tar_file $fileset");
	
}

&_main();
