#!/usr/bin/php
<?php
include "/usr/local/opmon/etc/config.php";

function get_perf_tables() {
	$query = "SHOW TABLES";
	$ret = do_query($query, DBPERF, OPDB_FETCH_OBJ);
	$tables = array();
	while(!$ret->EOF) {
		if (preg_match("/^service_perf_[0-9]+$/", $ret->fields->Tables_in_opperf))
			$tables[] = $ret->fields->Tables_in_opperf;
		$ret->MoveNext();
	}
	$ret->Close();
	return $tables;
}

function main() {

	$fields = array(
	    "hw_a" => "baseline",
	    "hw_t" => "lower_limit",
	    "hw" => "upper_limit",
	    "hw_dev" => "reserved0",
	    "last_hw" => "reserved1",
	    "last_hw_dev" => "reserved2"
	);

	$tables = get_perf_tables();
	foreach($tables as $t) {

		foreach($fields as $oldname => $newname) {
			$query = "ALTER IGNORE TABLE %s ".
				 "CHANGE %s %s float(13,3)";
			$query = sprintf(
			    $query,
			    $t,
			    $oldname,
			    $newname
			); 

			$ret = do_query($query, DBPERF);
			$ret->Close();
		}
	}

	return 0;
}

exit(main());

?>
