<?php

include("/usr/local/opmon/etc/config.php");
$opcfg=new ConfigManager();
$query="SELECT * from opmon_rtg;";
//$query="SELECT * from opmon_rtg WHERE host_id='7' AND service_id='397';";

$result=do_query($query, DBOPCFG, OPDB_FETCH_OBJ);
while( !$result->EOF ) {
	if(!$opcfg->cfg->get_host_info($result->fields->host_id, $tempHostInfo))
		return false;

	$sql="SELECT nedi_ifspeed FROM nagios_services where host_id='".$result->fields->host_id."' AND service_id='".$result->fields->service_id."';";	
	//print "$sql\n";
	$result2=do_query($sql, DBOPCFG, OPDB_FETCH_OBJ);
	if ($result2->RecordCount()>0) {
		$ifspeed=$result2->fields->nedi_ifspeed;
	}
	$result2->Close();
	if (empty($ifspeed)){
		$ifspeed=0;
	}

	$parameter=array();
	$parameter['parameter']="-v ".$tempHostInfo['snmp_version']." ";
	$parameter['parameter'].="-t ".$tempHostInfo['snmp_timeout']." ";
	$parameter['parameter'].="-r ".$tempHostInfo['snmp_retries']." ";
	$parameter['parameter'].="-c ".$tempHostInfo['community']." ";
	
	if ($tempHostInfo['snmp_version'] == 3) {
		if (isset($tempHostInfo['snmp_v3_secutiry_username']))
			$parameter['parameter'].="-u ".$tempHostInfo['snmp_v3_secutiry_username']." ";
		if (isset($tempHostInfo['snmp_v3_secutiry_level']))
			$parameter['parameter'].="-l ".$tempHostInfo['snmp_v3_secutiry_level']." ";
		if (isset($tempHostInfo['snmp_v3_auth_protocol']))
			$parameter['parameter'].="-a ".$tempHostInfo['snmp_v3_auth_protocol']." ";
		if (isset($tempHostInfo['snmp_v3_auth_passphrase']))
			$parameter['parameter'].="-A ".$tempHostInfo['snmp_v3_auth_passphrase']." ";
		if (isset($tempHostInfo['snmp_v3_privacy_protocol']))
			$parameter['parameter'].="-x ".$tempHostInfo['snmp_v3_privacy_protocol']." ";
		if (isset($tempHostInfo['snmp_v3_privacy_protocol_passphrase']))
			$parameter['parameter'].="-X ".$tempHostInfo['snmp_v3_privacy_protocol_passphrase']." ";
	}
	
	$parameter['parameter'].=$tempHostInfo['address'].":".$tempHostInfo['snmp_port']." ";
	$parameter['parameter'].=$result->fields->snmp_method." ";
	$parameter['parameter'].="\"".$result->fields->snmp_method_oid."\" ";
	$parameter['parameter'].="\"".$result->fields->snmp_method_ifname."\" ";
	$parameter['parameter'].=$ifspeed." ";
	$parameter['parameter'].=$result->fields->ifindex." ";
	// 64 bits counter
	$counter_64bits = 32;
	if ($result->fields->counter_64bits==1)
		$counter_64bits = 64;
	$parameter['parameter'].=$counter_64bits." ";
	$parameter['parameter'].=$result->fields->warning." ";
	$parameter['parameter'].=$result->fields->critical." ";
	$parameter['parameter'].=$result->fields->warning_errors." ";
	$parameter['parameter'].=$result->fields->critical_errors;
	$opcfg->cfg->delete_service_checkcommand_parameter("", $result->fields->service_id);
	$opcfg->cfg->add_service_command_parameter($result->fields->service_id, $parameter);
	//print $parameter['parameter']."\n\n";
	//print "ifspeed - <$ifspeed> - $sql\n";
	
	$result->MoveNext();
}
$result->Close();

?>
